;Stormtrooper file loading, cracking and trainer code by KrazyKato


;Bootsector decrypts to $8 and runs from there.
;6 tracks are then loaded to $17d22.
;This data is partly encrypted/messed with so it is then fixed and relocated down to $200.
;The game then runs from $200.

;Hardware interrupts, trace vector, vbl, keyboard and timers are then setup.
;2 more tracks are read and the "CREATION" logo is displayed.
;1 track is read and "Presents" is diplayed.
;More track are loaded then the music is started.
;On the original game a test made for 512k+ then the rest of the tracks are loaded to $80000.
;On my version the test is bypassed and the game carries on as though the ST is 512k to load the files.
;Personally I like to see the floppy deive light falshing on and off :-)

;$7970 is the main sub routine for track loading.
;$7a00 is called to do disk checks and read sector 3 hiscores. Now removed.
;My dma file loading qnd depacking routine is relocated to $80200.
;$7970 is patched with jmp $80200.
;The track file data is loaded and depacked to $30F5A, this is where the game had its track buffer.

;WARNING: I HAVE PLAYED THE GAME ALL THE WAY THROUGH FROM LEVEL 1 FROM THE PASTI IMAGE AND 
;FROM THE CRACKED VERSION AND THEY BOTH CRASH AT LEVEL 7 !!


;Trainer info:

;$9A74.b = Life counter.  Initialized at $47a.
;$9B59.b = Alt fire ammo. Subtracted at $fd0  held at $25d(a6)
;$9B21.b = Level Start.   Initialized at $460. = move.w #0,$224(a6)
;$919B.b = Ascii level value.

	
	opt	o+,ow-			;optimize

	clr.l	-(a7)			;enter supervisor mode
	move.w	#$20,-(a7)
	trap	#1
	addq.l	#6,a7
	
	bchg	#0,$484 		;annoying click off !

	bsr	menu			;do the simple menu bit
	
;on exit from menu
;d4=0 or 1 for yes no lives
;d5=0 or 1 for yes no ammo
;d6=start level

;-------------  Loader Starts here ------------------------


;do some screen stuff from the original bootsector

	move.b	#2,$ffff820a		
  	move.b	#7,$ffff8201 
      	move.b  #-$80,$ffff8203
      	clr.w   $ffff8240
      	clr.b   $ffff8260
	

;$7290 = main sector loader.   Replace with file loader at $80200
;Relocate DMAFILE.S code to $80200
;Must remove check for high memory!
;D0=track
;$30F5A = track read buffer


;First relocate the loading and depacking code to $80200

	lea	dma(pc),a0
	lea	$80200,a1
	move.l	#dmaend-dma,d0
relodma	move.b	(a0)+,(a1)+
	dbra	d0,relodma

	lea	dat200(pc),a0
	bsr	unpack
		

;Next relocate the game code down to $200

relo200	lea	dat200,a0
	lea	$200,a1
	move.l	#38654,d0

	move.w	#$2700,sr	;interrupts off (very important!!)
down	move.b	(a0)+,(a1)+
	dbra	d0,down


;Game code is then patched to crack the track/sector loading and disk checks.
	
	move.w	#$601e,$8b8		;remove track 62 check
	move.w	#$601c,$278		;remove track 29 check
	move.w	#$6010,$6B14		;remove track 40 check
	move.w	#$601a,$1dac		;remove track 40 check

	move.l	#$4ef90008,$7970	;patch in a jump to my file routine jmp $80200 (jmp $80200)
	move.w	#$0200,$7972+4
	move.w	#$6050,$77C2		;ignore high memory check
	move.l	#$1e3c00ff,$781c	;move.b	#-1,d7	(this was the dma register value - tricky!)
	move.l	#$4e714e71,$bea		;remove saving hiscores to disk
	
	;move.w	#$ffff,$47c		;lives counter=65535  
					;i did this first to test it before I found
					;where it was being decreased from.

	cmp.b	#1,d4			;test menu option for infinite lives
	bne	amm

life	move.l	#$4e714e71,$258e	;no life decrease when shot or attacked.
	move.w	#$4e71,$258e+4		;(nop nop nop)
	move.l	#$4e714e71,$24ea	;no life decrease when ran over by boulders etc.
	move.w	#$4e71,$24ea+4		;(nop nop nop)
	
		
amm	cmp.b	#1,d5			;test menu option for infinite ammo
	bne	stlevel
	move.w	#$4e71,$fd0		;infinite Alt fire ammo. Press space to use after picking up 
	
stlevel	sub	#1,d6			;proper start level from menu options
	move.w	d6,$462			;start level   0=level 1, 1=level 2, etc, etc
					;7 levels ?
	
	jmp	$200			;start the game code

menu	include	"menu.s"
	
dma:	include "dmafile.s"		;loading and depacking routine
dmaend:

dat200:	incbin	"gamedat"		;decrypted and (SPv3) packed game code

